=== benchmarks/CMakeLists.txt ===
add_subdirectory(mnist)
add_subdirectory(octopusarm)
add_subdirectory(p300speller)
add_subdirectory(polebalancing)
add_subdirectory(twospirals)
add_subdirectory(cifar10)
add_subdirectory(sarcos)
add_subdirectory(iris)
