=== examples/CMakeLists.txt ===
add_subdirectory(polebalancing)
add_subdirectory(twospirals)
add_subdirectory(xor)
add_subdirectory(sine)
