=== src/CMakeLists.txt ===
project(OpenANNLibrary)

configure_file(OpenANN.cpp.in ${PROJECT_SOURCE_DIR}/OpenANN.cpp)
add_definitions(${OPENANN_COMPILER_FLAGS})
file(GLOB_RECURSE openann_src "*.cpp")
add_library(openann SHARED ${openann_src})
if(OPENMP_FOUND)
  target_link_libraries(openann gomp)
endif()
target_link_libraries(openann alglib)
install(TARGETS openann DESTINATION lib)
