=== benchmarks/iris/CMakeLists.txt ===
project(IrisBenchmark)

file(COPY benchmark.py DESTINATION .)
