=== debian/changelog ===
rock-master-20.06-data-processing-openann (0.20150524-1~buster) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-data-processing/data_processing-openann.git
  * branch: refs/heads/master
  * commit: 7b73eb76d4c5686125513f9f173f5171e8db4216
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Mon, 07 Sep 2020 13:09:03 +0200
